
/* All conditionals taken outside of loop and loop replicated, if Cyc == 2. */
/* This file contains all the proceedures for each instance of hh.mat loop.*/
/* Cyc (i,j) loops unwrapped for speed, if Cyc == 1 | 2. */
/*jcr24jul90*/

#include "local.h"
#include <math.h>
#include <stdio.h>  /*For NULL definition*/
#include "em.typ"
#include "hharray.h"
#include "son.h"

/*Global variables for hh array load*/
extern Rtyp ff_re,ff_im;
extern int Capm,Capn,Capm2,Capn2;
extern int loss,xsym;
extern int mo_odd,no_odd;
extern struct hharray hh;
extern int gx,gy;  /* = 1 for cos, = 0 for sin */
extern void (*ffp)();  /*pointer to function to do ff term, e.g., ff*/
extern int *ni0,*mi0;
extern Rtyp *hre,*him,*hrez,*himz;

hlp15c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp15c2*/

hlp7c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp7c2*/

hlp11c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /*mo_odd && !no_odd && gx && gy*/

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp11c2*/

hlp3c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && !no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp3c2*/

hlp13c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp13c2*/

hlp5c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp5c2*/

hlp9c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && !no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp9c2*/

hlp1c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && !no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp1c2*/

hlp14c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp14c2*/

hlp6c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp6c2*/

hlp10c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && !no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp10c2*/

hlp2c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && !no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp2c2*/

hlp12c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp12c2*/

hlp4c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp4c2*/

hlp8c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* mo_odd && !no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp8c2*/

hlp0c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi;
  /* !mo_odd && !no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++) *(hh.mat_im + hh.n * i + *ni) = *(him+i);
  }
} /*hlp0c2*/

hlp31c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /*loss &&  mo_odd && no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp31c2*/

hlp23c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp23c2*/

hlp27c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /*mo_odd && !no_odd && gx && gy*/

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp27c2*/

hlp19c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && !no_odd && gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp19c2*/

hlp29c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp29c2*/

hlp21c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp21c2*/

hlp25c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && !no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp25c2*/

hlp17c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && !no_odd && !gx && gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp17c2*/

hlp30c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp30c2*/

hlp22c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp22c2*/

hlp26c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && !no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp26c2*/

hlp18c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && !no_odd && gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp18c2*/

hlp28c2()
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int *ni,*mi,i,j,m,n;
  Rtyp xi,xr;
  /* mo_odd && no_odd && !gx && !gy */

  for (ni=ni0,n=1; *ni>=0; ni++,n=xsym+( (*ni)<<xsym ))
  { *hre = *hrez = *him = *himz = 0.0;
    for (mi=mi0; (m = *mi)>=0; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(him+m) = 0.25 * xi;  *(hre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    hk_interp(him,mi0);
    cs_fft(him,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    hk_interp(hre,mi0);
    cs_fft(hre,gx,mo_odd,0,Capm);
    for (i=0; i<hh.m; i++)
    { *(hh.mat_im + hh.n * i + *ni) = *(him+i);
      *(hh.mat_re + hh.n * i + *ni) = *(hre+i);
    }
  }
} /*hlp28c2*/
